package com.vladmarica.betterpingdisplay.hud;

import com.mojang.blaze3d.systems.RenderSystem;
import com.vladmarica.betterpingdisplay.BetterPingDisplayMod;
import com.vladmarica.betterpingdisplay.Config;
import com.vladmarica.betterpingdisplay.mixin.PlayerListHudInvoker;
import net.minecraft.class_310;
import net.minecraft.class_327;
import net.minecraft.class_355;
import net.minecraft.class_4587;
import net.minecraft.class_640;

public final class CustomPlayerListHud {
  private static final int PING_TEXT_RENDER_OFFSET = -13;
  private static final int PING_BARS_WIDTH = 11;
  private static final Config config = BetterPingDisplayMod.instance().getConfig();

  public static void renderPingDisplay(
          class_310 client, class_355 hud, class_4587 matrixStack, int width, int x, int y, class_640 player) {
    class_327 textRenderer = client.field_1772;

    String pingString = String.format(config.getTextFormatString(), player.method_2959());
    int pingStringWidth = textRenderer.method_1727(pingString);
    int pingTextColor = config.shouldAutoColorPingText() ? PingColors.getColor(player.method_2959()) : config.getTextColor();
    int textX = width + x - pingStringWidth + PING_TEXT_RENDER_OFFSET;

    if (!config.shouldRenderPingBars()) {
      textX += PING_BARS_WIDTH;
    }

    // Draw the ping text for the given player
    textRenderer.method_1720(matrixStack, pingString, (float) textX, (float) y, pingTextColor);

    if (config.shouldRenderPingBars()) {
      ((PlayerListHudInvoker) hud).invokeRenderLatencyIcon(matrixStack, width, x, y, player);
    } else {
      // If we don't render ping bars, we need to reset the render system color so the rest
      // of the player list renders properly
      RenderSystem.setShaderColor(1.0F, 1.0F, 1.0F, 1.0F);
    }
  }
}
